
Redmine - Patch #819

Add a body ID and class to all pages

2008-03-09 16:59 - Ale Muñoz

Status: Closed Start date: 2008-03-09

Priority: Normal Due date:  

Assignee: Eric Davis % Done: 100%

Category: UI Estimated time: 0.00 hour

Target version: 1.0.1   

Description

This is extremely useful for CSS styling, as it allows us theme writers to target specific pages/sections.

It will also allow for a cleaner/easier menu styling (patch coming soon : )

Related issues:

Has duplicate Redmine - Feature #5547: Add class of controller+view (home_wel... Closed 2010-05-18

Associated revisions

Revision 3911 - 2010-08-04 03:17 - Eric Davis

Added css classes to the HTML body based on the theme, controller, and action. #819

History

#1 - 2008-03-09 17:02 - Ale Muñoz

This applies to r1217

#2 - 2008-03-09 17:17 - Jean-Philippe Lang

It could be convenient indeed. But I see a clash with the "account" div defined in base.rhtml:

<div id="account">

    <%= render_menu :account_menu -%>

</div>

 Since account is also a controller's name, this would cause a duplicate id in the rendered html.

Class names may also be already in use for something else (eg. list which is also an action name).

Could we prefix the controller and action name instead ? Maybe something like that:

&lt;body id="ctrl_<%= @controller.controller_name >" class="action_<= @controller.action_name %>">

 What do you think ?

#3 - 2008-03-09 20:12 - Ale Muñoz

Another (less nice) option is to use id="<%= @controller.controller_name >_<= @controller.action_name %"

The only problem I see with this method is you cannot easily style all pages that belong to a controller.

Also, you could rename the "account" DIV with a less problematic (and probably more semantic) "account_menu".

I'll prepare a patch for this later option. It's an easy change, and the benefits of having a common ID for pages produced by the same controller are

well worth the effort.

#4 - 2008-03-09 20:29 - Ale Muñoz

- File redmine_add_body_id_and_css_fixes.patch added

Here's a patch that adds @<body id="<%= @controller.controller_name %>" class="<%= @controller.action_name %>">@ and renames all DIVs

with IDs that conflict with the new body IDs.

It also changes the global CSS to make sure nothing loses its current styling.

It applies to r1223

#5 - 2008-03-09 20:32 - Ale Muñoz
One note, though.

I have not checked for every element with CLASS="action_name" for every controller.

I'll check for this next week and will submit a patch if it's needed.

#6 - 2010-08-04 03:18 - Eric Davis

- Status changed from New to Resolved

- Assignee set to Eric Davis

- Target version set to 1.0.1

- % Done changed from 0 to 100

I had a similar idea but I also included the theme name.  This will make it much easier for css to target specific pages and also make theme-specific

css easy.

<body class="controller-settings action-edit"> 

<body class="theme-Alternate controller-issues action-show"> 

 Committed in r3911

#7 - 2010-08-19 06:35 - Eric Davis

- Status changed from Resolved to Closed

Merged to 1.0-stable for release in 1.0.1.

Files

redmine_add_body_id.patch 546 Bytes 2008-03-09 Ale Muñoz

redmine_add_body_id_and_css_fixes.patch 1.95 KB 2008-03-09 Ale Muñoz
